dashboards/urls.py
from django.urls import path
import dashboards.views

app_name = "dashboards"

urlpatterns = [
    path("", dashboards.views.Data.as_view(), name="index"),  # The main index view
]

nsp/urls.py
import api.views
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import include, path, re_path

from drf_yasg import openapi
from drf_yasg.views import get_schema_view

from rest_framework import routers, permissions
from rest_framework.authtoken import views
from django.template.defaulttags import register


@register.filter
def get_item(dictionary, key):
    return dictionary.get(key)


openapi_info = openapi.Info(
    title="NSP",
    default_version="0.1.0",
    description="Network Science Platform",
    contact=openapi.Contact(email="keith.birdsall@aicloud.guru"),
    license=openapi.License(name="MIT License"),
)

schema_view = get_schema_view(
    openapi_info,
    public=True,
    permission_classes=[permissions.AllowAny],
)


class OptionalSlashRouter(routers.DefaultRouter):
    def __init__(self):
        super().__init__()
        self.trailing_slash = "/?"


api_router = OptionalSlashRouter()

api_router.register(r"admin/users", api.views.UserViewSet)
api_router.register(r"admin/groups", api.views.GroupViewSet)

api_router.register(r"tenants", api.views.TenantViewSet)
api_router.register(r"epgs", api.views.EndpointGroupViewSet)
api_router.register(r"jobs", api.views.JobViewSet)
api_router.register(r"executions", api.views.JobExecutionViewSet)
api_router.register(r"results", api.views.JobResultViewSet)
api_router.register(r"devices", api.views.DeviceViewSet)
api_router.register(r"dashboards", api.views.DashboardViewSet)
api_router.register(r"networks", api.views.BaseNetworkViewSet)
api_router.register(r"vrfs", api.views.VrfViewSet)
api_router.register(r"l3vnis", api.views.L3VniViewSet)
api_router.register(r"vlans", api.views.VlanViewSet)
api_router.register(r"interfaces", api.views.InterfaceViewSet)
#api_router.register(r"snapshots", api.views.SnapshotViewSet)

urlpatterns = [
    path("admin/", admin.site.urls),
    path("api-auth/", include("rest_framework.urls", namespace="rest_framework")),
    path("api-token-auth/", views.obtain_auth_token),
    path("api/", include(api_router.urls)),
    # path("api/epgs/", api.views.EndpointGroupList.as_view()),
    # path("api/epgs/<int:id>/", api.views.EndpointGroupDetail.as_view()),
    path("login/", include("login.urls")),
    path("networks/", include("networks.urls")),
    path("jobs/", include("jobs.urls")),
    path("dashboards/", include("dashboards.urls")),
    path("settings/", include("settings.urls")),
    path("devices/", include("devices.urls")),
    re_path(
        r"^api/swagger(?P<format>\.json|\.yaml)$",
        schema_view.without_ui(cache_timeout=0),
        name="schema-json",
    ),
    re_path(
        r"^api/swagger/$",
        schema_view.with_ui("swagger", cache_timeout=0),
        name="schema-swagger-ui",
    ),
    re_path(
        r"^api/redoc/$",
        schema_view.with_ui("redoc", cache_timeout=0),
        name="schema-redoc",
    ),
    path("", include("devices.urls")),
    path("", include("django_prometheus.urls")),
] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

dashboards/models.py
from django.db import models
from django_prometheus.models import ExportModelOperationsMixin


class BaseDashboard(ExportModelOperationsMixin("dashboard"), models.Model):
    id = models.AutoField(primary_key=True)
    name = models.CharField(max_length=50, blank=True)

dashboards/views.py
import dashboards.models
import utils.helpers
from asgiref.sync import sync_to_async
from django.http import HttpResponseRedirect
from django.views import generic
from django.shortcuts import render
from django_apscheduler.models import DjangoJobExecution
from devices.models import BaseNetworkDevice
from networks.models import BaseNetwork


class Data(generic.View):
    def get(self, request):
        device_executions_count = BaseNetworkDevice.objects.count()
        network_executions_count = BaseNetwork.objects.count()
        job_executions_count = DjangoJobExecution.objects.count()

        return render(request, "dashboards/index.html", {
            "device_count": device_executions_count,
            "network_count": network_executions_count,
            "job_count": job_executions_count,  # Add more variables as needed
        })

dashboards/templates/dashboards/index.html
{% extends 'base.html' %}
{% load static %}

{% block sidebar %}
{% endblock sidebar %}

{% block content-title %}
<nav title="breadcrumb">
  <ol class="breadcrumb">
    <li class="breadcrumb-item" aria-current="page"><a href="{% url 'dashboards:index' %}">Dashboards</a></li>
  </ol>
</nav>
{% endblock content-title %}

{% block content %}
<div class="row">
  <div class="col-lg-4">
    <div class="card mb-4">
      <div class="card-body">
        <i class="fa-solid fa-server fa-xl"></i>
        <h5 class="card-title">Onboarded Devices</h5>
        <p class="card-text" style="font-size: 24px; color: blue;">{{device_count}}</p>

      </div>
    </div>
  </div>

  <div class="col-lg-4">
    <div class="card mb-4">
      <div class="card-body">
        <i class="fa-solid fa-diagram-project fa-xl"></i>
        <h5 class="card-title">Total Networks</h5>
        <p class="card-text" style="font-size: 24px; color: blue;">{{network_count}}</p>
      </div>
    </div>
  </div>

  <div class="col-lg-4">
    <div class="card mb-4">
      <div class="card-body">
        <i class="fa-solid fa-gear fa-xl"></i>
        <h5 class="card-title">Submitted Jobs</h5>
        <p class="card-text" style="font-size: 24px; color: blue;">{{job_count}}</p>
      </div>
    </div>
  </div>

{% endblock content %}

{% block javascript %}
<script src="{% static 'dashboards/js/dashboards.js' %}"></script>
{% endblock javascript %}
</div>